#!/usr/bin/python
# -*- coding: utf-8 -*-
import os, sys
import codecs

ENCODING = "utf-8"
LIBRARY = "tsi.src"
INPUT = "input.txt"
OUTPUT = "output.txt"
CHARS = 3

def readLibrary():
    libs = []
    libFile = codecs.open(LIBRARY, "r", ENCODING) 
    for line in libFile.readlines():
        word = line.split(" ")[0]
        if len(word) == 2:
            libs.append(word)
    libFile.close()
    return libs

def readQuery():
    inputFile = codecs.open(INPUT, "r", ENCODING)
    queries = inputFile.read().replace(u"\uFEFF", "").split(u",")
    for x in range(0, CHARS):
        queries[x] = queries[x].strip()
    inputFile.close()    
    return queries

def findWords(libs, queries):
    wordSet = []
    for x in range(0, CHARS):
        words = []
        for y in range(0, len(libs)):  
            if queries[x] in libs[y]:
                words.append(libs[y])
        wordSet.append(words)
    return wordSet
    
def findDiff(diffSet, queries):
    for x in range(0, CHARS):
        char = []
        for y in range(0, len(diffSet[x])):
            diffSet[x][y] = diffSet[x][y].replace(queries[x], u"")
    return diffSet
    
def findAnswers(diffSet):
    outputFile = codecs.open(OUTPUT, "w", ENCODING) 
    outputFile.write(u"\uFEFF")
    for x in range(0, len(diffSet[0])):
        matches = 0
        for y in range(1, len(diffSet)):
            for z in range(0, len(diffSet[y])):
                if diffSet[0][x] == diffSet[y][z]:
                    matches = matches + 1
                    break
        if matches == (CHARS -1):
            outputFile.write(u"%s\n" % diffSet[0][x])
    outputFile.close()            

def xword():
    appdir = os.path.abspath(os.path.dirname(sys.argv[0]))
    os.chdir(appdir) 
    if os.path.exists(LIBRARY):
        if os.path.exists(INPUT):
            libs = readLibrary()
            queries = readQuery()
            wordSet = findWords(libs, queries)
            diffSet = findDiff(wordSet, queries)
            findAnswers(diffSet)
            print "Done."
        else:
            print "Input not found, abort."
    else:
        print "Library not found, abort."
    
if __name__ == "__main__":
    xword()
    
    